import * as React from "react";
import { IColDef, IProps as ITableProps } from "@dccs/react-table-plain";
import { IState } from "./IState";
export declare type OnLoadData = (page: number, rowsPerPage: number, orderBy: string, desc: boolean, filter: {
    [key: string]: any;
}) => Promise<{
    total: number;
    data: any[];
}>;
export interface IRenderPagingProps extends IState {
    handleChangePage: (page: number) => void;
    handleChangeRowsPerPage: (rows: number) => void;
}
interface IProps {
    colDef: IColDef[];
    initRowsPerPage?: number;
    onLoadData: OnLoadData;
    disablePaging?: boolean;
    tableTheme?: any;
    onRowClick?: (data: any) => void;
    subComponent?: (data: any) => React.ReactNode;
    renderTable?: (ps: ITableProps) => React.ReactElement;
    renderLoading?: () => React.ReactElement;
    renderError?: (load: () => void) => React.ReactElement;
    renderPaging?: (props: IRenderPagingProps) => React.ReactElement;
}
export declare function DataGridPlain(props: IProps): JSX.Element;
export {};
