"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSource = function (get, url) { return function (page, rowsPerPage, orderBy, desc, filter) {
    var urlSep = url.indexOf("?") === -1 ? "?" : "&";
    var p = new Promise(function (res, rej) {
        get("" + url + urlSep + "page=" + page + "&count=" + rowsPerPage + "&orderBy=" + orderBy + "&desc=" + desc + serializeFilter(filter || {}))
            .then(function (resp) { return res({ data: resp.data, total: resp.total }); })
            .catch(rej);
    });
    return p;
}; };
function serializeFilter(filter) {
    var query = "";
    // tslint:disable-next-line:forin
    for (var x in filter) {
        if (filter[x] != null) {
            query += "&" + x + "=" + encodeURIComponent(filter[x]);
        }
    }
    return query;
}
